diff --git a/src/backend/replication/logical/decode.c b/src/backend/replication/logical/decode.c
index cc03f0706e9..ab46a27a2b5 100644
--- a/src/backend/replication/logical/decode.c
+++ b/src/backend/replication/logical/decode.c
@@ -150,34 +150,34 @@ xlog_decode(LogicalDecodingContext *ctx, XLogRecordBuffer *buf)
 			 */
 			break;
 		case XLOG_PARAMETER_CHANGE:
+
+			/*
+			 * Even if wal_level on the primary got decreased to 'replica', as
+			 * long as there is at least one valid logical slot, the logical
+			 * decoding remains enabled. So we don't check the logical
+			 * decoding availability here but do so in
+			 * XLOG_LOGICAL_DECODING_STATUS_CHANGE case. It covers the case
+			 * where wal_level on the primary got decreased to 'minimal' too.
+			 */
+			break;
+		case XLOG_LOGICAL_DECODING_STATUS_CHANGE:
 			{
-				xl_parameter_change *xlrec =
-					(xl_parameter_change *) XLogRecGetData(buf->record);
+				bool	   *logical_decoding = (bool *) XLogRecGetData(buf->record);
 
-				/*
-				 * If wal_level on the primary is reduced to less than
-				 * logical, we want to prevent existing logical slots from
-				 * being used.  Existing logical slots on the standby get
-				 * invalidated when this WAL record is replayed; and further,
-				 * slot creation fails when wal_level is not sufficient; but
-				 * all these operations are not synchronized, so a logical
-				 * slot may creep in while the wal_level is being reduced.
-				 * Hence this extra check.
-				 */
-				if (xlrec->wal_level < WAL_LEVEL_LOGICAL)
+				if (!(*logical_decoding))
 				{
 					/*
 					 * This can occur only on a standby, as a primary would
-					 * not allow to restart after changing wal_level < logical
+					 * not allow to restart after changing wal_level < replica
 					 * if there is pre-existing logical slot.
 					 */
 					Assert(RecoveryInProgress());
 					ereport(ERROR,
 							(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
-							 errmsg("logical decoding on standby requires \"wal_level\" >= \"logical\" on the primary")));
+							 errmsg("logical decoding on standby requires \"effective_wal_level\" >= \"logical\" on the primary")));
 				}
-				break;
 			}
+			break;
 		case XLOG_NOOP:
 		case XLOG_NEXTOID:
 		case XLOG_SWITCH:
diff --git a/src/backend/replication/logical/logical.c b/src/backend/replication/logical/logical.c
index 93ed2eb368e..5194aa72471 100644
--- a/src/backend/replication/logical/logical.c
+++ b/src/backend/replication/logical/logical.c
@@ -36,6 +36,7 @@
 #include "pgstat.h"
 #include "replication/decode.h"
 #include "replication/logical.h"
+#include "replication/logicalctl.h"
 #include "replication/reorderbuffer.h"
 #include "replication/slotsync.h"
 #include "replication/snapbuild.h"
@@ -117,31 +118,31 @@ CheckLogicalDecodingRequirements(void)
 	 * needs the same check.
 	 */
 
-	if (wal_level < WAL_LEVEL_LOGICAL)
-		ereport(ERROR,
-				(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
-				 errmsg("logical decoding requires \"wal_level\" >= \"logical\"")));
-
 	if (MyDatabaseId == InvalidOid)
 		ereport(ERROR,
 				(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
 				 errmsg("logical decoding requires a database connection")));
 
-	if (RecoveryInProgress())
-	{
-		/*
-		 * This check may have race conditions, but whenever
-		 * XLOG_PARAMETER_CHANGE indicates that wal_level has changed, we
-		 * verify that there are no existing logical replication slots. And to
-		 * avoid races around creating a new slot,
-		 * CheckLogicalDecodingRequirements() is called once before creating
-		 * the slot, and once when logical decoding is initially starting up.
-		 */
-		if (GetActiveWalLevelOnStandby() < WAL_LEVEL_LOGICAL)
-			ereport(ERROR,
-					(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
-					 errmsg("logical decoding on standby requires \"wal_level\" >= \"logical\" on the primary")));
-	}
+	/* CheckSlotRequirements() has already checked if wal_level >= 'replica' */
+
+	/*
+	 * Check if logical decoding is available on standbys. Typically, when
+	 * running a standby, RecoveryInProgress() returning true implies that
+	 * LogicalDecodingStatusChangeAllowed() is false. However, during
+	 * promotion, there is a brief transitional phase where
+	 * RecoveryInProgress() remains true even though
+	 * LogicalDecodingStatusChangeAllowed() has already turned true.
+	 *
+	 * In this window, logical decoding enable/disable operations are
+	 * permitted on standby, anticipating its transition to primary. The
+	 * actual wait for recovery completion is handled within
+	 * start_logical_decoding_status_change().
+	 */
+	if (!IsLogicalDecodingEnabled() && !LogicalDecodingStatusChangeAllowed())
+		ereport(ERROR,
+				(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
+				 errmsg("logical decoding on standby requires \"effective_wal_level\" >= \"logical\" on the primary"),
+				 errhint("Set \"wal_level\" >= \"logical\" or create at least one logical slot when \"wal_level\" = \"replica\".")));
 }
 
 /*
diff --git a/src/backend/replication/logical/logicalctl.c b/src/backend/replication/logical/logicalctl.c
new file mode 100644
index 00000000000..c26a4cf6f82
--- /dev/null
+++ b/src/backend/replication/logical/logicalctl.c
@@ -0,0 +1,701 @@
+/*-------------------------------------------------------------------------
+ * logicalctl.c
+ *		Functionality to control logical decoding status online.
+ *
+ * This module enables dynamic control of logical decoding availability.
+ * Logical decoding becomes active under two conditions: when the wal_level
+ * parameter is set to 'logical', or when at least one valid logical replication
+ * slot exists with wal_level set to 'replica'. The system disables logical
+ * decoding when neither condition is met. Therefore, the dynamic control
+ * of logical decoding availability is required only when wal_level is set
+ * to 'replica'. Logical decoding is always enabled when wal_level='logical'
+ * and always disabled when wal_level='minimal'.
+ *
+ * The core concept of dynamically enabling and disabling logical decoding
+ * is to separately control two aspects: writing information required for
+ * logical decoding to WAL records, and using logical decoding itself. During
+ * activation, we first enable logical WAL writing while keeping logical
+ * decoding disabled. This change is reflected in the read-only
+ * effective_wal_level GUC parameter. Once we ensure that all processes have
+ * updated to the latest effective_wal_level value, we then enable logical
+ * decoding. Deactivation follows a similar careful, multi-step process
+ * in reverse order.
+ *
+ * While activation occurs synchronously right after creating the first
+ * logical slot, deactivation happens asynchronously through the checkpointer
+ * process. This design choice exists because deactivation requires waiting
+ * for concurrent attempts to update the logical decoding status, which can be
+ * problematic when the process is holding interrupts. This situation arises
+ * when a process cleans up temporary or ephemeral slots on error or at process
+ * exit without releasing temporary slots explicitly. This lazy approach has
+ * a drawback: it may take longer to change the effective_wal_level and disable
+ * logical decoding, especially when the checkpointer is busy with other tasks.
+ * However, since dropping or invalidating the last slot should not happen
+ * frequently, we chose this approach in all deactivation cases for simpler code
+ * implementation, even though the lazy approach is required only in error cases
+ * or at process exit time in principle. In the future, we could address this
+ * limitation either by using a dedicated worker instead of the checkpointer, or
+ * by implementing synchronous waiting during slot drops if workloads are
+ * significantly affected by the lazy deactivation of logical decoding.
+ *
+ * Standby servers use the primary server's effective_wal_level and logical
+ * decoding status. Unlike normal activation and deactivation, these
+ * are updated simultaneously without status change coordination, solely by
+ * replaying XLOG_LOGICAL_DECODING_STATUS_CHANGE records. The local wal_level
+ * setting has no effect during this time. Upon promotion, we update the
+ * logical decoding status based on local conditions: the wal_level value and
+ * the presence of logical slots.
+ *
+ * In the future, we could extend support to include automatic transitions
+ * of effective_wal_level between 'minimal' and 'logical' WAL levels. However,
+ * this enhancement would require additional coordination mechanisms and
+ * careful implementation of operations such as terminating walsenders and
+ * archiver processes while carefully considering the sequence of operations
+ * to ensure system stability during these transitions.
+ *
+ * Portions Copyright (c) 1996-2025, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * IDENTIFICATION
+ * 	  src/backend/replication/logical/logicalctl.c
+ *
+ *-------------------------------------------------------------------------
+ */
+
+#include "postgres.h"
+
+#include "access/xloginsert.h"
+#include "catalog/pg_control.h"
+#include "miscadmin.h"
+#include "storage/condition_variable.h"
+#include "storage/ipc.h"
+#include "storage/lmgr.h"
+#include "storage/proc.h"
+#include "storage/procarray.h"
+#include "replication/logicalctl.h"
+#include "replication/slot.h"
+#include "utils/injection_point.h"
+#include "utils/wait_event.h"
+#include "utils/wait_event_types.h"
+
+/*
+ * Struct for controlling the logical decoding status.
+ *
+ * This struct is protected by LogicalDecodingControlLock.
+ */
+typedef struct LogicalDecodingCtlData
+{
+	/*
+	 * This is the authoritative value used by all processes to determine
+	 * whether to write additional information required by logical decoding to
+	 * WAL. Since this information could be checked frequently, each process
+	 * caches this value in XLogLogicalInfo for better performance.
+	 */
+	bool		xlog_logical_info;
+
+	/* True if logical decoding is available in the system */
+	bool		logical_decoding_enabled;
+
+	/*
+	 * This flag indicates whether logical decoding status changes are
+	 * allowed. It is false during recovery and becomes true when recovery
+	 * ends. Even when true, it specifically means "allowed after recovery has
+	 * fully completed".
+	 *
+	 * This flag helps prevent race conditions with the startup process's
+	 * end-of-recovery actions. After the startup process updates the logical
+	 * decoding status at recovery end, other processes might attempt to
+	 * toggle logical decoding before recovery fully completes (i.e.,
+	 * RecoveryInProgress() returns false) - a period when WAL writes are
+	 * still not permitted. Therefore, when this flag is true, we must wait
+	 * for recovery to fully complete before attempting an activation or a
+	 * deactivation.
+	 */
+	bool		status_change_allowed;
+
+	/* True while the logical decoding status is being changed */
+	bool		status_change_inprogress;
+
+	/* True if logical decoding might need to be disabled */
+	bool		pending_disable;
+
+	/* Condition variable signaled when a status change completes */
+	ConditionVariable cv;
+} LogicalDecodingCtlData;
+
+static LogicalDecodingCtlData *LogicalDecodingCtl = NULL;
+
+/*
+ * A process local cache of LogicalDecodingCtl->xlog_logical_info. This is
+ * initialized at process startup time, and could be updated when absorbing
+ * the process barrier signal in ProcessBarrierUpdateXLogLogicalInfo().
+ */
+bool		XLogLogicalInfo = false;
+
+static void update_xlog_logical_info(void);
+static void abort_logical_decoding_activation(int code, Datum arg);
+static bool start_logical_decoding_status_change(bool new_status);
+
+Size
+LogicalDecodingCtlShmemSize(void)
+{
+	return sizeof(LogicalDecodingCtlData);
+}
+
+void
+LogicalDecodingCtlShmemInit(void)
+{
+	bool		found;
+
+	LogicalDecodingCtl = ShmemInitStruct("Logical decoding control",
+										 LogicalDecodingCtlShmemSize(),
+										 &found);
+
+	if (!found)
+	{
+		MemSet(LogicalDecodingCtl, 0, LogicalDecodingCtlShmemSize());
+		ConditionVariableInit(&LogicalDecodingCtl->cv);
+	}
+}
+
+/*
+ * Initialize the logical decoding status in shmem at server startup. This
+ * must be called ONCE during postmaster or standalone-backend startup.
+ */
+void
+StartupLogicalDecodingStatus(bool last_status)
+{
+	/* Logical decoding is always disabled when 'minimal' WAL level */
+	if (wal_level == WAL_LEVEL_MINIMAL)
+		return;
+
+	/*
+	 * Set the initial logical decoding status based on the last status. If
+	 * logical decoding was enabled before the last shutdown, it remains
+	 * enabled as we might have set wal_level='logical' or have a few logical
+	 * slots.
+	 */
+	UpdateLogicalDecodingStatus(last_status, false);
+}
+
+/*
+ * Update the XLogLogicalInfo cache.
+ */
+static inline void
+update_xlog_logical_info(void)
+{
+	XLogLogicalInfo = IsXLogLogicalInfoEnabled();
+}
+
+/*
+ * Initialize XLogLogicalInfo backend-private cache. This routine is called
+ * during process initialization.
+ */
+void
+InitializeProcessXLogLogicalInfo(void)
+{
+	update_xlog_logical_info();
+}
+
+/*
+ * This routine is called when we are ordered to update XLogLogicalInfo
+ * by a ProcSignalBarrier.
+ */
+bool
+ProcessBarrierUpdateXLogLogicalInfo(void)
+{
+	update_xlog_logical_info();
+	return true;
+}
+
+/*
+ * Check the shared memory state and return true if logical decoding is
+ * enabled on the system.
+ */
+bool
+IsLogicalDecodingEnabled(void)
+{
+	bool		enabled;
+
+	LWLockAcquire(LogicalDecodingControlLock, LW_SHARED);
+	enabled = LogicalDecodingCtl->logical_decoding_enabled;
+	LWLockRelease(LogicalDecodingControlLock);
+
+	return enabled;
+}
+
+/*
+ * Returns true if logical WAL logging is enabled based on the shared memory
+ * status.
+ */
+bool
+IsXLogLogicalInfoEnabled(void)
+{
+	bool		xlog_logical_info;
+
+	LWLockAcquire(LogicalDecodingControlLock, LW_SHARED);
+	xlog_logical_info = LogicalDecodingCtl->xlog_logical_info;
+	LWLockRelease(LogicalDecodingControlLock);
+
+	return xlog_logical_info;
+}
+
+/*
+ * Enable or disable both the status of logical info WAL logging and logical
+ * decoding in shmem.
+
+ * Note that this function updates the global flags without the state transition
+ * process. EnsureLogicalDecodingEnabled() and DisableLogicalDecodingIfNecessary()
+ * should be used instead if there could be concurrent processes doing writes
+ * or logical decoding, particularly once the status change is allowed globally.
+ */
+void
+UpdateLogicalDecodingStatus(bool new_status, bool need_lock)
+{
+	if (need_lock)
+		LWLockAcquire(LogicalDecodingControlLock, LW_EXCLUSIVE);
+
+	/* It must be called before allowing the status change globally */
+	Assert(!LogicalDecodingCtl->status_change_allowed);
+
+	LogicalDecodingCtl->xlog_logical_info = new_status;
+	LogicalDecodingCtl->logical_decoding_enabled = new_status;
+
+	if (need_lock)
+		LWLockRelease(LogicalDecodingControlLock);
+
+	elog(DEBUG1, "update logical decoding status to %d", new_status);
+}
+
+/*
+ * A PG_ENSURE_ERROR_CLEANUP callback for activating logical decoding, resetting
+ * the shared flags to revert the logical decoding activation process.
+ */
+static void
+abort_logical_decoding_activation(int code, Datum arg)
+{
+	Assert(LogicalDecodingCtl->status_change_inprogress);
+
+	elog(DEBUG1, "aborting logical decoding activation process");
+
+	LWLockAcquire(LogicalDecodingControlLock, LW_EXCLUSIVE);
+	LogicalDecodingCtl->xlog_logical_info = false;
+	LWLockRelease(LogicalDecodingControlLock);
+
+	/*
+	 * Some processes might have already started logical info WAL logging, so
+	 * tell all running processes to update their caches. We don't need to
+	 * wait for all processes to disable xlog_logical_info locally as it's
+	 * always safe to write logical information to WAL records, even when not
+	 * strictly required.
+	 */
+	EmitProcSignalBarrier(PROCSIGNAL_BARRIER_UPDATE_XLOG_LOGICAL_INFO);
+
+	LWLockAcquire(LogicalDecodingControlLock, LW_EXCLUSIVE);
+	LogicalDecodingCtl->status_change_inprogress = false;
+	LWLockRelease(LogicalDecodingControlLock);
+
+	/* Let waiters know the status change completed */
+	ConditionVariableBroadcast(&LogicalDecodingCtl->cv);
+}
+
+/*
+ * Returns the status_change_allowed flag in LogicalDecodingCtl. The caller
+ * might need to check RecoveryInProgress() as well. Please see the comments for
+ * the status_change_allowed flag for details.
+ */
+bool
+LogicalDecodingStatusChangeAllowed(void)
+{
+	bool		status_change_allowed;
+
+	LWLockAcquire(LogicalDecodingControlLock, LW_SHARED);
+	status_change_allowed = LogicalDecodingCtl->status_change_allowed;
+	LWLockRelease(LogicalDecodingControlLock);
+
+	return status_change_allowed;
+}
+
+/*
+ * This function does several kinds of preparation works required to start
+ * the process of logical decoding status change. If the status change is
+ * required, it sets LogicalDecodingCtl->status_change_inprogress, and
+ * returns true. Otherwise, if it's not required or not allowed (e.g., logical
+ * slots exist or during recovery) it returns false.
+  */
+static bool
+start_logical_decoding_status_change(bool new_status)
+{
+	if (!LogicalDecodingStatusChangeAllowed())
+		return false;
+
+	if (RecoveryInProgress())
+	{
+		/*
+		 * Wait for the recovery to complete. Note that even the checkpointer
+		 * can wait for the recovery to complete here without concerning
+		 * deadlocks unless the startup process performs any action that waits
+		 * for it after calling UpdateLogicalDecodingStatusEndOfRecovery().
+		 */
+
+		elog(DEBUG1,
+			 "waiting for recovery completion to change logical decoding status");
+		do
+		{
+			CHECK_FOR_INTERRUPTS();
+
+			pgstat_report_wait_start(WAIT_EVENT_LOGICAL_DECODING_STATUS_CHANGE_DELAY);
+			pg_usleep(100000L); /* wait for 100 msec */
+			pgstat_report_wait_end();
+		}
+		while (RecoveryInProgress());
+
+		/*
+		 * Now that writing WAL records are officially allowed, start the
+		 * logical decoding status change.
+		 */
+	}
+
+retry:
+	LWLockAcquire(LogicalDecodingControlLock, LW_EXCLUSIVE);
+
+	/*
+	 * When attempting to disable logical decoding, if there is at least one
+	 * valid logical slot, we cannot disable it. We need to check it here
+	 * since slots could be created or dropped while waiting for the status
+	 * change below.
+	 */
+	if (!new_status && CheckLogicalSlotExists())
+	{
+		LogicalDecodingCtl->pending_disable = false;
+		LWLockRelease(LogicalDecodingControlLock);
+		return false;
+	}
+
+	/* If a status change is in-progress, we need to wait for completion */
+	if (LogicalDecodingCtl->status_change_inprogress)
+	{
+		/* Release the lock and wait for someone to complete the transition */
+		LWLockRelease(LogicalDecodingControlLock);
+		ConditionVariableSleep(&LogicalDecodingCtl->cv,
+							   WAIT_EVENT_LOGICAL_DECODING_STATUS_CHANGE);
+
+		goto retry;
+	}
+
+	/* Return if we don't need to change the status */
+	if (LogicalDecodingCtl->logical_decoding_enabled == new_status)
+	{
+		LogicalDecodingCtl->pending_disable = false;
+		LWLockRelease(LogicalDecodingControlLock);
+		return false;
+	}
+
+	/* Mark the state transition is in-progress */
+	LogicalDecodingCtl->status_change_inprogress = true;
+
+	LWLockRelease(LogicalDecodingControlLock);
+
+	return true;
+}
+
+/*
+ * Enable logical decoding if disabled.
+ *
+ * If this function is called during recovery, it simply returns without
+ * action since the logical decoding status change is not allowed during
+ * this time. The logical decoding status depends on the status on the primary.
+ * The caller can use CheckLogicalDecodingRequirements() before calling this
+ * function to make sure that the logical decoding status can be modified.
+ *
+ * Note that there is no interlock between logical decoding activation
+ * and slot creation. To ensure enabling logical decoding, the caller
+ * needs to call this function after creating a logical slot before
+ * initializing the logical decoding context.
+ */
+void
+EnsureLogicalDecodingEnabled(void)
+{
+	Assert(MyReplicationSlot);
+
+	if (wal_level == WAL_LEVEL_MINIMAL)
+		ereport(ERROR,
+				errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
+				errmsg("cannot enable logical decoding when \"wal_level\" = \"minimal\""));
+
+	/* Logical decoding is always enabled */
+	if (wal_level >= WAL_LEVEL_LOGICAL)
+		return;
+
+	/* Prepare and start the activation process if it's disabled */
+	if (!start_logical_decoding_status_change(true))
+		return;
+
+	/*
+	 * Ensure we reset the activation process if we cancelled or errored out
+	 * below
+	 */
+	PG_ENSURE_ERROR_CLEANUP(abort_logical_decoding_activation, (Datum) 0);
+	{
+		/*
+		 * Set logical info WAL logging in shmem. All process starts after
+		 * this point will include the information required by logical
+		 * decoding to WAL records.
+		 */
+		LWLockAcquire(LogicalDecodingControlLock, LW_EXCLUSIVE);
+		LogicalDecodingCtl->xlog_logical_info = true;
+		LWLockRelease(LogicalDecodingControlLock);
+
+		/*
+		 * Tell all running processes to reflect the xlog_logical_info update,
+		 * and wait. This ensures that all running processes have enabled
+		 * logical information WAL logging.
+		 */
+		WaitForProcSignalBarrier(
+								 EmitProcSignalBarrier(PROCSIGNAL_BARRIER_UPDATE_XLOG_LOGICAL_INFO));
+
+		INJECTION_POINT("logical-decoding-activation", NULL);
+
+		/*
+		 * There could be some transactions that might have started with the
+		 * old status, but we don't need to wait for these transactions to
+		 * complete. These transactions will appear in the xl_running_xacts
+		 * record and therefore the snapshot builder will not try to decode
+		 * the transaction during the logical decoding initialization.
+		 */
+	}
+	PG_END_ENSURE_ERROR_CLEANUP(abort_logical_decoding_activation, (Datum) 0);
+
+	START_CRIT_SECTION();
+
+	/*
+	 * We enable logical decoding first, followed by writing the WAL record.
+	 * This sequence ensures logical decoding becomes available on the primary
+	 * first.
+	 */
+	LWLockAcquire(LogicalDecodingControlLock, LW_EXCLUSIVE);
+	LogicalDecodingCtl->logical_decoding_enabled = true;
+	LWLockRelease(LogicalDecodingControlLock);
+
+	{
+		XLogRecPtr	recptr;
+		bool		logical_decoding = true;
+
+		XLogBeginInsert();
+		XLogRegisterData(&logical_decoding, sizeof(bool));
+		recptr = XLogInsert(RM_XLOG_ID, XLOG_LOGICAL_DECODING_STATUS_CHANGE);
+		XLogFlush(recptr);
+	}
+
+	/* Complete the transition */
+	LWLockAcquire(LogicalDecodingControlLock, LW_EXCLUSIVE);
+	LogicalDecodingCtl->status_change_inprogress = false;
+	LogicalDecodingCtl->pending_disable = false;
+	LWLockRelease(LogicalDecodingControlLock);
+
+	END_CRIT_SECTION();
+
+	ereport(LOG,
+			errmsg("logical decoding is enabled upon creating a new logical replication slot"));
+
+	/* Let waiters know the work finished */
+	ConditionVariableBroadcast(&LogicalDecodingCtl->cv);
+}
+
+/*
+ * Initiate a request for disabling logical decoding.
+ *
+ * This function expects to be called after dropping or invalidating the
+ * possibly-last logical replication slot as it doesn't check the logical slot presence.
+ */
+void
+RequestDisableLogicalDecoding(void)
+{
+	volatile PROC_HDR *procglobal = ProcGlobal;
+	ProcNumber	checkpointerProc = procglobal->checkpointerProc;
+
+	if (wal_level != WAL_LEVEL_REPLICA)
+		return;
+
+	/*
+	 * Check if the status change is allowed before initiating a disable
+	 * request, to avoid unnecessary work.
+	 */
+	if (!LogicalDecodingStatusChangeAllowed())
+		return;
+
+	/*
+	 * It's possible that we might not actually need to disable logical
+	 * decoding if someone creates a new logical slot concurrently. We set the
+	 * flag anyway and the checkpointer will check it and disable logical
+	 * decoding if necessary.
+	 */
+	LWLockAcquire(LogicalDecodingControlLock, LW_EXCLUSIVE);
+	LogicalDecodingCtl->pending_disable = true;
+	LWLockRelease(LogicalDecodingControlLock);
+
+	/* Wake up the checkpointer */
+	if (checkpointerProc != INVALID_PROC_NUMBER)
+		SetLatch(&GetPGProcByNumber(checkpointerProc)->procLatch);
+
+	elog(DEBUG1, "requested disabling logical decoding");
+}
+
+/*
+ * Disable logical decoding if necessary.
+ *
+ * This function disables logical decoding upon a request initiated by
+ * RequestDisableLogicalDecoding(). Otherwise, it performs no action.
+ */
+void
+DisableLogicalDecodingIfNecessary(void)
+{
+	bool		pending_disable;
+
+	if (wal_level != WAL_LEVEL_REPLICA)
+		return;
+
+	/*
+	 * Sanity check as we cannot disable logical decoding while holding a
+	 * logical slot.
+	 */
+	Assert(!MyReplicationSlot);
+
+	LWLockAcquire(LogicalDecodingControlLock, LW_SHARED);
+	pending_disable = LogicalDecodingCtl->pending_disable;
+	LWLockRelease(LogicalDecodingControlLock);
+
+	/* Quick return if no pending disable request */
+	if (!pending_disable)
+		return;
+
+	/* Prepare and start the deactivation process if it's enabled */
+	if (!start_logical_decoding_status_change(false))
+		return;
+
+	/*
+	 * We don't need PG_ENSURE_ERROR_CLEANUP() to abort the deactivation
+	 * process as all subsequent operations are expected to be
+	 * non-interruptible and not to throw an ERROR or a FATAL.
+	 */
+
+	START_CRIT_SECTION();
+
+	/*
+	 * We need to disable logical decoding first and then disable logical
+	 * information WAL logging in order to ensure that no logical decoding
+	 * processes WAL records with insufficient information.
+	 */
+	LWLockAcquire(LogicalDecodingControlLock, LW_EXCLUSIVE);
+	LogicalDecodingCtl->logical_decoding_enabled = false;
+	LWLockRelease(LogicalDecodingControlLock);
+
+	/* Write the WAL to disable logical decoding on standbys too */
+	if (XLogStandbyInfoActive())
+	{
+		bool		logical_decoding = false;
+		XLogRecPtr	recptr;
+
+		XLogBeginInsert();
+		XLogRegisterData(&logical_decoding, sizeof(bool));
+		recptr = XLogInsert(RM_XLOG_ID, XLOG_LOGICAL_DECODING_STATUS_CHANGE);
+		XLogFlush(recptr);
+	}
+
+	/* Now disable logical information WAL logging */
+	LWLockAcquire(LogicalDecodingControlLock, LW_EXCLUSIVE);
+	LogicalDecodingCtl->xlog_logical_info = false;
+	LWLockRelease(LogicalDecodingControlLock);
+
+	/*
+	 * Tell all running processes to reflect the xlog_logical_info update.
+	 * Unlike when enabling logical decoding, we don't need to wait for all
+	 * processes to complete it in this case. We already disabled logical
+	 * decoding and it's always safe to write logical information to WAL
+	 * records, even when not strictly required. Therefore, we don't need to
+	 * wait for all running transactions to finish either.
+	 */
+	EmitProcSignalBarrier(PROCSIGNAL_BARRIER_UPDATE_XLOG_LOGICAL_INFO);
+
+	/* Complete the transition */
+	LWLockAcquire(LogicalDecodingControlLock, LW_EXCLUSIVE);
+	LogicalDecodingCtl->status_change_inprogress = false;
+	LogicalDecodingCtl->pending_disable = false;
+	LWLockRelease(LogicalDecodingControlLock);
+
+	END_CRIT_SECTION();
+
+	ereport(LOG,
+			errmsg("logical decoding is disabled because all logical replication slots are removed"));
+
+	/* Let waiters know the work finished */
+	ConditionVariableBroadcast(&LogicalDecodingCtl->cv);
+}
+
+/*
+ * Update the logical decoding status at end of the recovery. This function
+ * must be called before accepting writes.
+ */
+void
+UpdateLogicalDecodingStatusEndOfRecovery(void)
+{
+	bool		new_status = false;
+	bool		need_wal = false;
+
+	Assert(RecoveryInProgress());
+	Assert(!LogicalDecodingCtl->status_change_inprogress);
+
+	/* With 'minimal' WAL level, logical decoding is always disabled */
+	if (wal_level == WAL_LEVEL_MINIMAL)
+	{
+		Assert(!IsXLogLogicalInfoEnabled() && !IsLogicalDecodingEnabled());
+		return;
+	}
+
+	LWLockAcquire(LogicalDecodingControlLock, LW_EXCLUSIVE);
+
+	if (wal_level == WAL_LEVEL_LOGICAL || CheckLogicalSlotExists())
+		new_status = true;
+
+	if (LogicalDecodingCtl->logical_decoding_enabled != new_status)
+		need_wal = true;
+
+	/*
+	 * Update shmem flags. We don't need to care about the order of setting
+	 * global flag and writing the WAL record as writes are not allowed yet.
+	 */
+	UpdateLogicalDecodingStatus(new_status, false);
+
+	/*
+	 * Mark the end-of-recovery action has been done, allowing processes to
+	 * change the logical decoding status after the recovery finished.
+	 */
+	LogicalDecodingCtl->status_change_allowed = true;
+
+	LWLockRelease(LogicalDecodingControlLock);
+
+	if (need_wal)
+	{
+		XLogRecPtr	recptr;
+
+		Assert(XLogStandbyInfoActive());
+
+		XLogBeginInsert();
+		XLogRegisterData(&new_status, sizeof(bool));
+		recptr = XLogInsert(RM_XLOG_ID, XLOG_LOGICAL_DECODING_STATUS_CHANGE);
+		XLogFlush(recptr);
+	}
+
+	/*
+	 * Ensure all running processes have the updated status. We don't need to
+	 * wait for running transactions to finish as we don't accept any writes
+	 * yet. We need the wait even if we've not updated the status above as the
+	 * status have been turned on and off during recovery, having running
+	 * processes have different status on their local caches.
+	 */
+	if (IsUnderPostmaster)
+		WaitForProcSignalBarrier(
+								 EmitProcSignalBarrier(PROCSIGNAL_BARRIER_UPDATE_XLOG_LOGICAL_INFO));
+
+	INJECTION_POINT("startup-logical-decoding-status-change-end-of-recovery", NULL);
+}
diff --git a/src/backend/replication/logical/meson.build b/src/backend/replication/logical/meson.build
index 9283e996ef4..a0cd113db5f 100644
--- a/src/backend/replication/logical/meson.build
+++ b/src/backend/replication/logical/meson.build
@@ -6,6 +6,7 @@ backend_sources += files(
   'decode.c',
   'launcher.c',
   'logical.c',
+  'logicalctl.c',
   'logicalfuncs.c',
   'message.c',
   'origin.c',
diff --git a/src/backend/replication/logical/slotsync.c b/src/backend/replication/logical/slotsync.c
index b122d99b009..9e10111b349 100644
--- a/src/backend/replication/logical/slotsync.c
+++ b/src/backend/replication/logical/slotsync.c
@@ -56,6 +56,7 @@
 #include "pgstat.h"
 #include "postmaster/interrupt.h"
 #include "replication/logical.h"
+#include "replication/logicalctl.h"
 #include "replication/slotsync.h"
 #include "replication/snapbuild.h"
 #include "storage/ipc.h"
@@ -1057,13 +1058,15 @@ bool
 ValidateSlotSyncParams(int elevel)
 {
 	/*
-	 * Logical slot sync/creation requires wal_level >= logical.
+	 * Logical slot sync/creation requires logical decoding to be enabled.
 	 */
-	if (wal_level < WAL_LEVEL_LOGICAL)
+	if (!IsLogicalDecodingEnabled())
 	{
 		ereport(elevel,
 				errcode(ERRCODE_INVALID_PARAMETER_VALUE),
-				errmsg("replication slot synchronization requires \"wal_level\" >= \"logical\""));
+				errmsg("replication slot synchronization requires \"effective_wal_level\" >= \"logical\" on the primary"),
+				errhint("To enable logical decoding on primary, set \"wal_level\" >= \"logical\" or create at least one logical slot when \"wal_level\" = \"replica\"."));
+
 		return false;
 	}
 
